      SUBROUTINE Energy_GEDIIS(MRESET,MSET,ci,GeomSet,GradSet,ESET,NCoord,ER_star)
!----------------------------------------------------------------------
!  Copyright 2003-2014 Ecole Normale Supérieure de Lyon, 
!  Centre National de la Recherche Scientifique,
!  Université Claude Bernard Lyon 1. All rights reserved.
!
!  This work is registered with the Agency for the Protection of Programs 
!  as IDDN.FR.001.100009.000.S.P.2014.000.30625
!
!  Authors: P. Fleurat-Lessard, P. Dayal
!  Contact: optnpath@gmail.com
!
! This file is part of "Opt'n Path".
!
!  "Opt'n Path" is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Affero General Public License as
!  published by the Free Software Foundation, either version 3 of the License,
!  or (at your option) any later version.
!
!  "Opt'n Path" is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Affero General Public License for more details.
!
!  You should have received a copy of the GNU Affero General Public License
!  along with "Opt'n Path". If not, see <http://www.gnu.org/licenses/>.
!
! Contact The Office of Technology Licensing, valorisation@ens-lyon.fr,
! for commercial licensing opportunities.
!----------------------------------------------------------------------

      IMPLICIT NONE
      integer, parameter :: KINT = kind(1)
      integer, parameter :: KREAL = kind(1.0d0)


    INTEGER(KINT) :: MRESET, MSET, NCoord
    REAL(KREAL) :: ci(MRESET), GeomSet(MRESET*NCoord), GradSet(MRESET*NCoord), ESET(MRESET)
    REAL(KREAL) :: ER_star, tmp
    
    INTEGER(KINT) :: I, IX, JX, INV, JNV, KX
    
    LOGICAL PRINT
    
      PRINT=.FALSE.
    
      IF (PRINT)  WRITE(*,'(/,''      BEGIN Energy_GEDIIS   '')')
    
      ER_star=0.D0
      INV=-NCoord
      DO IX=1,MSET
         INV=INV+NCoord
         JNV=-NCoord
         DO JX=1,MSET
            JNV=JNV+NCoord
            tmp=0.D0
          DO KX=1, NCoord
             tmp = tmp + (((GradSet(INV+KX)-GradSet(JNV+KX))*(GeomSet(INV+KX)-GeomSet(JNV+KX)))/2.D0)
          END DO
      ER_star = ER_star + ci(IX)*ci(JX)*tmp
         END DO
      END DO

    DO I=1, MSET
       ER_star = ER_star + (ci(I)*ESET(I))    
    END DO

      IF (PRINT)  WRITE(*,'(/,''       END Energy_GEDIIS  '',/)')

      END SUBROUTINE Energy_GEDIIS
